#include <iostream>
#include <cstdlib>
#include <cmath>
#include <ctime>
#include <string>
#include <vector>
#include <queue>
using namespace std;
// #include <GL/glut.h> // 環境によって変える
//#include "./glut.h"
#include <GLUT/glut.h> // for Mac
#pragma comment(lib, "./glut32.lib")

#define PI 3.141592
#define FULLSCREEN_MODE 0 // 0ならウィンドウ，1ならフルスクリーンでマウス非表示
#define WINDOW_WIDTH 640
#define WINDOW_HEIGHT 480

int key_up = 0, key_down = 0, key_left = 0, key_right = 0, key_space = 0; // キー状態を記録
unsigned long long global_time = 0;

float faceX = 0, faceY = 0, faceRadius = 1.0;
float myFaceX = WINDOW_WIDTH/2, myFaceY = WINDOW_HEIGHT/2 + 100;
float myX = 0, myY = 0, myZ = 35;

#include "GLColor.h"
#include "LongHall.h"

LongHall hall;

#include <opencv2/objdetect/objdetect.hpp>
#include <opencv2/highgui/highgui.hpp>
#include <opencv2/imgproc/imgproc.hpp>


#define IMG_SCALE 2 // 1だと重すぎる，4だとちょっと離れたら認識しなくなる
using namespace cv;

queue<pair<float, pair<float, float> > > peekQue; // peek用キュー <radius, <x, y>>
String cascadeName = "/Users/usi3/Desktop/OpenCV-2.2.0/data/haarcascades/haarcascade_frontalface_alt.xml";
CvCapture* capture = 0;
Mat frame, frameCopy, image;  
CascadeClassifier cascade;


// キー操作
void keyDown(unsigned char key, int x, int y){
	switch(key){
        case ' ':
            key_space = 1;
            break;
        case '\33':
            if(FULLSCREEN_MODE) glutLeaveGameMode();
            exit(0);
            break;
        case 'e':
			myFaceX = faceX;
            myFaceY = faceY;
            break;    
        default:
            break;
	}
}
void keyUp(unsigned char key, int x, int y){
	switch(key){
        case ' ':
            key_space = 0;
            break;
        default:
            break;
	}
}
void specialKeyDown(int key, int x, int y){
	switch(key){
        case GLUT_KEY_UP:
            key_up = 1;
            break;
        case GLUT_KEY_DOWN:
            key_down = 1;
            break;
        case GLUT_KEY_LEFT:
            key_left = 1;
            break;
        case GLUT_KEY_RIGHT:
            key_right = 1;
            break;
        default:
            break;
	}
}
void specialKeyUp(int key, int x, int y){
	switch(key){
        case GLUT_KEY_UP:
            key_up = 0;
            break;
        case GLUT_KEY_DOWN:
            key_down = 0;
            break;
        case GLUT_KEY_LEFT:
            key_left = 0;
            break;
        case GLUT_KEY_RIGHT:
            key_right = 0;
            break;
        default:
            break;
	}
}

// 表示制御
void display(void){ 
    glClearColor(0, 0, 0, 0);
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
    
    if (!peekQue.empty()) {
        pair<float, pair<float, float> > faceInfo = peekQue.back();
        peekQue.pop();
        faceX += (faceInfo.second.first/12 - faceX)*0.1;
        faceY += (faceInfo.second.second/6 - faceY)*0.1;
        faceRadius += ((faceInfo.first-30) - faceRadius)*0.1;
        //cout << "faceY = " << faceY << endl;
        cout << "faceRadius = " << faceRadius << endl;
    }
    
    // 視点変更
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    gluPerspective(32.0, (double)WINDOW_WIDTH / (double)WINDOW_HEIGHT, 1.0, 300.0);
    glTranslated(0.0, 0.0, 0.0);
    //gluLookAt(0.0, 0.0, myZ-faceRadius, faceX, faceY, myZ-35-faceRadius, 0.0, 1.0, 0.0);
    gluLookAt(0.0, 0.0, myZ, faceX, faceY, myZ-35, 0.0, 1.0, 0.0);
    
    // オブジェクト描画
    glMatrixMode(GL_MODELVIEW);
    glLoadIdentity();
    
    //glRotatef(-faceX, 0, 0, 1);
    //glRotatef(-faceY, 1, 0, 0);
    //glScaled(faceRadius, faceRadius, faceRadius);
    
    // フィールド
    hall.display();
    
    // ダブルバッファリング
    glutSwapBuffers();

}
// 画面 and 視点制御
void reshape(GLsizei w, GLsizei h){
	// 画面の大きさを変更する
    cout << "reshape w = " << w << "h = " << h << endl;
	glutReshapeWindow(WINDOW_WIDTH, WINDOW_HEIGHT);
    
	glViewport(0, 0, w, h);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(32.0, (double)w / (double)h, 1.0, 300.0);
    
	glTranslated(0.0, 0.0, 0.0);
	gluLookAt(0.0, 0.0, 35.0, 0.0, 0.0, 0.0, 0.0, 1.0, 0.0);
}

void detectAndDraw(Mat& img, CascadeClassifier& cascade){
    vector<Rect> faces;
    
    // CV_8UC1: 1チャネル8ビットunsigned char
    Mat gray, smallImg(cvRound(img.rows/IMG_SCALE), cvRound(img.cols/IMG_SCALE), CV_8UC1); 
    
    // 色空間をカラーからグレースケールへ変換
    cvtColor(img, gray, CV_BGR2GRAY);
    // IMG_SCALEに応じて小さくする
    resize(gray, smallImg, smallImg.size(), 0, 0, INTER_LINEAR);
    equalizeHist(smallImg, smallImg);
    
    double t = (double)cvGetTickCount();
    cascade.detectMultiScale( smallImg, faces,
                             1.1, 2, 0
                             //|CV_HAAR_FIND_BIGGEST_OBJECT
                             //|CV_HAAR_DO_ROUGH_SEARCH
                             |CV_HAAR_SCALE_IMAGE
                             ,
                             Size(30, 30) );
    t = (double)cvGetTickCount() - t;
    //printf("detection time = %g ms\n", t/((double)cvGetTickFrequency()*1000.));
    
    // 1つの顔にしか対応しないことにする
    vector<Rect>::const_iterator r = faces.begin();
    
    // 顔が1つ以上検出されているなら最初の顔のみについて処理
    if (r != faces.end()) {
        Point center;
        center.x = cvRound((r->x + r->width*0.5)*IMG_SCALE);
        center.y = cvRound((r->y + r->height*0.5)*IMG_SCALE);
        //cout << center.x << " " << center.y << endl;
        // ディスプレイを正面から見たとき顔は下の方に映るからyを半分引いてない．
        float radius = cvRound((r->width + r->height)*0.25*IMG_SCALE);
        circle( img, center, radius, CV_RGB(0,0,255), 3, 8, 0 );
        // radius  34 - 190 くらい
        peekQue.push(make_pair(radius, make_pair(center.x-myFaceX, center.y-myFaceY))); 
    }
    
    imshow("result", img);    
}

void cvTimer(){
    // for debug
    //if (rand()%100 < 10) {
    //int x = cos(global_time/5)*320;
    //int y = sin(global_time/5)*320;
    //peekQue.push(make_pair(x, y));
    //}
    
    IplImage* iplImg = cvQueryFrame(capture);
    frame = iplImg;
    if(frame.empty()){
        return;
    }
    if(iplImg->origin == IPL_ORIGIN_TL){
        frame.copyTo(frameCopy);
    }else{
        flip(frame, frameCopy, 0);
    }
    
    detectAndDraw(frameCopy, cascade);
}

// メインループ
void timer(int value){
	glutPostRedisplay();
	glutTimerFunc(50, timer, 0);
    cvTimer();
    global_time++;
    
    if (key_up == 1) {
        myZ -= 1;
    }
    if (key_down == 1) {
        myZ += 1;
    }
}

void glInit(){
	glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE | GLUT_DEPTH);
    
	if(FULLSCREEN_MODE){
		glutGameModeString("1024x768:32@60");
		glutEnterGameMode();
	}else{
		glutInitWindowPosition(100, 100);
		glutInitWindowSize(WINDOW_WIDTH, WINDOW_HEIGHT);
		glutCreateWindow("HeadTrackingSample (OpenGL/GLUT)");
	}
    
	glutReshapeFunc(reshape);
	glutDisplayFunc(display);
	// キー操作
	glutKeyboardFunc(keyDown);
	glutKeyboardUpFunc(keyUp);
	glutSpecialFunc(specialKeyDown);
	glutSpecialUpFunc(specialKeyUp);
    
	glClearColor(0, 0, 0, 0);
    
	// 光源
    GLfloat light1Pos[] = {-5, -5, 35, 1};
    GLfloat light2Pos[] = {-5, 5, 35, 1};
    GLfloat light3Pos[] = {5, 5, 35, 1};
    GLfloat light4Pos[] = {5, -5, 35, 1};
    GLfloat lightCol[] = {1.0, 1.0, 1.0, 1};
    
	glLightfv(GL_LIGHT0, GL_POSITION, light1Pos);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, lightCol);
    glLightf(GL_LIGHT0, GL_SPECULAR, 1.0);
    glLightf(GL_LIGHT0, GL_AMBIENT, 0.2);
    
	glLightfv(GL_LIGHT1, GL_POSITION, light2Pos);
	glLightfv(GL_LIGHT1, GL_DIFFUSE, lightCol);
    glLightf(GL_LIGHT1, GL_SPECULAR, 1.0);
    glLightf(GL_LIGHT1, GL_AMBIENT, 0.2);
    
    glLightfv(GL_LIGHT2, GL_POSITION, light3Pos);
	glLightfv(GL_LIGHT2, GL_DIFFUSE, lightCol);
    glLightf(GL_LIGHT2, GL_SPECULAR, 1.0);
    glLightf(GL_LIGHT2, GL_AMBIENT, 0.2);
    
    glLightfv(GL_LIGHT3, GL_POSITION, light4Pos);
	glLightfv(GL_LIGHT3, GL_DIFFUSE, lightCol);
    glLightf(GL_LIGHT3, GL_SPECULAR, 1.0);
    glLightf(GL_LIGHT3, GL_AMBIENT, 0.2);
    
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glEnable(GL_LIGHT1);
    glEnable(GL_LIGHT2);
	glEnable(GL_LIGHT3);
	glEnable(GL_DEPTH_TEST);
}

void cvInit(){
    if(!cascade.load(cascadeName)){
        cerr << "ERROR: Could not load classifier cascade" << endl;
        return;
    }
    capture = cvCaptureFromCAM(0);
    if(!capture){
        cerr << "Capture from CAM didn't work" << endl;
        return;
    }
    cvNamedWindow("result", 1);
}

// 各種初期化とメインループへの移行
int main(int argc, char *argv[]){
    srand(time(NULL));
	glutInit(&argc, argv);
    glInit();
    cvInit();
    
	glutTimerFunc(50, timer, 0);
	glutMainLoop();
    
	return 0;
}
